import { ElementRef, EventEmitter, ChangeDetectorRef, SimpleChanges, OnInit, OnChanges, OnDestroy, AfterViewInit } from '@angular/core';
import { CIService } from '../lib.service';
import { DomSanitizer } from '@angular/platform-browser';
import { Observable, Subscription } from 'rxjs';
export declare class ImgComponent implements OnInit, OnChanges, AfterViewInit, OnDestroy {
    private ciService;
    private _sanitizer;
    private cd;
    private platformId;
    imgElem: ElementRef;
    pictureElem: ElementRef;
    src: string;
    class: string;
    alt: string;
    operation: string;
    o: string;
    size: string | {};
    s: string | {};
    filters: string;
    f: string;
    ratio: number;
    offset: number;
    ngSwitch: any;
    lazyLoading: boolean | null;
    emptyOnSsr: boolean;
    imageLoaded: EventEmitter<any>;
    resizeObservable$: Observable<Event>;
    resizeSubscription$: Subscription;
    cloudimageUrl: string;
    sources: any[];
    firstSource: any;
    restSources: any[];
    isLoaded: boolean;
    isProcessed: boolean;
    isPreview: boolean;
    previewCloudimageUrl: string;
    previewSources: any[];
    isAdaptive: boolean;
    actualSize: string;
    parentContainerWidth: string;
    isPreviewLoaded: boolean;
    isRatio: boolean;
    ratioBySize: number;
    imageHeight: number;
    windowInnerWidth: number;
    isSsr: boolean;
    readonly isLazyLoadingMode: any;
    constructor(ciService: CIService, _sanitizer: DomSanitizer, cd: ChangeDetectorRef, platformId: Object);
    ngOnDestroy(): void;
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterViewInit(): void;
    processImage(): void;
    onImageLoad($event: any): void;
    getRestSources(): any[];
    getFirstSource(): any;
    getPositionStyle(): import("@angular/platform-browser").SafeStyle;
    getImgHeight(): import("@angular/platform-browser").SafeStyle;
    getTransformStyle(): import("@angular/platform-browser").SafeStyle;
    getTransitionStyle(): import("@angular/platform-browser").SafeStyle;
    getFilterStyle(): import("@angular/platform-browser").SafeStyle;
    getPicturePaddingBottom(): import("@angular/platform-browser").SafeStyle;
    getPictureBackground(): import("@angular/platform-browser").SafeStyle;
}
